
Global funcywidth%,funcyheight%,funcytone%

Function UpdateFuncyElements()
	DrawImage funcytone%,-1,0
End Function

Function InitFuncyElements(gw%,gh%)
	funcywidth%=gw%
	funcyheight%=gh%
	funcytone%=CreateImage(funcywidth%,funcyheight%)
	MaskImage funcytone%,20,20,20
End Function

Function DrawFuncyOval(mx#,my#,a1#,a2#,linetype$,linecolor$)
	Local a#,x#,y#,gapon%,gapstep%,gap#,g1%,l1%,g2%,l2%,red%,green%,blue%
	Select linecolor$
		Case "white"
			red%=255:green%=255:blue%=255
		Case "red"
			red%=255:green%=0:blue%=0
		Case "green"
			red%=0:green%=255:blue%=0
		Case "blue"
			red%=0:green%=0:blue%=255
		Case "yellow"
			red%=255:green%=255:blue%=0
		Case "cyan"
			red%=0:green%=255:blue%=255
		Case "magenta"
			red%=255:green%=0:blue%=255
		Default
			red%=255:green%=255:blue%=255
	End Select
	Select linetype$
		Case "solid"
			gapstep%=4
		Case "center"
			g1%=20:l1%=5:g2%=1:l2%=5
		Case "dashed"
			g1%=20:l1%=5:g2%=20:l2%=5
		Case "dotted"
			g1%=1:l1%=10:g2%=1:l2%=10
		Case "doubledash"
			g1%=10:l1%=2:g2%=10:l2%=20
		Case "crisp"
			g1%=1:l1%=2:g2%=1:l2%=2
		Default
			gapstep%=4
	End Select
	
	SetBuffer ImageBuffer(funcytone%)
	LockBuffer ImageBuffer(funcytone%)
	If a1#>a2# Then
		x#=-a1#
		gap#=x#
		While x#<a1#
			x#=x#+(precision#/a1#)
			If x#>gap#+(g1%*a1#)/a1# And gapstep%=0 Then gap#=x#:gapon%=1:gapstep%=1
			If x#>gap#+(l1%*a1#)/a1# And gapstep%=1 Then gap#=x#:gapon%=0:gapstep%=2
			If x#>gap#+(g2%*a1#)/a1# And gapstep%=2 Then gap#=x#:gapon%=1:gapstep%=3
			If x#>gap#+(l2%*a1#)/a1# And gapstep%=3 Then gap#=x#:gapon%=0:gapstep%=0
			y#=Sqr(a2#^2*(1-(x#^2/a1#^2)))
			If mx#+x#>=0 And mx#+x#<=funcywidth% And my#+y#>=0 And my#+y#<=funcyheight% Then
				If gapon%=0 Then WritePixelFast mx#+x#,my#+y#,red% Shl 16+green% Shl 8+blue%
			End If
			If mx#+x#>=0 And mx#+x#<=funcywidth% And my#-y#>=0 And my#-y#<=funcyheight% Then	
				If gapon%=0 Then WritePixelFast mx#+x#,my#-y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
	Else
		y#=-a2#
		gap#=y#
		While y#<a2#
			y#=y#+(precision#/a2#)
			If y#>gap#+(g1%*a1#)/a2# And gapstep%=0 Then gap#=y#:gapon%=1:gapstep%=1
			If y#>gap#+(l1%*a1#)/a2# And gapstep%=1 Then gap#=y#:gapon%=0:gapstep%=2
			If y#>gap#+(g2%*a1#)/a2# And gapstep%=2 Then gap#=y#:gapon%=1:gapstep%=3
			If y#>gap#+(l2%*a1#)/a2# And gapstep%=3 Then gap#=y#:gapon%=0:gapstep%=0
			x#=Sqr(a1#^2*(1-(y#^2/a2#^2)))
			If mx#+x#>=0 And mx#+x#<=funcywidth% And my#+y#>=0 And my#+y#<=funcyheight% Then
				If gapon%=0 Then WritePixelFast mx#+x#,my#+y#,red% Shl 16+green% Shl 8+blue%
			End If
			If mx#-x#>=0 And mx#-x#<=funcywidth% And my#+y#>=0 And my#+y#<=funcyheight% Then	
				If gapon%=0 Then WritePixelFast mx#-x#,my#+y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
	End If
	
	UnlockBuffer ImageBuffer(funcytone%)
	SetBuffer BackBuffer()
End Function

Function DrawFuncyLine(x1#,y1#,x2#,y2#,linetype$,linecolor$)
	Local gap#,gapon%,gapstep%,y#,x#,m#,n#,g1%,l1%,g2%,l2%,red%,green%,blue%
	Select linecolor$
		Case "white"
			red%=255:green%=255:blue%=255
		Case "red"
			red%=255:green%=0:blue%=0
		Case "green"
			red%=0:green%=255:blue%=0
		Case "blue"
			red%=0:green%=0:blue%=255
		Case "yellow"
			red%=255:green%=255:blue%=0
		Case "cyan"
			red%=0:green%=255:blue%=255
		Case "magenta"
			red%=255:green%=0:blue%=255
		Default
			red%=255:green%=255:blue%=255	
	End Select
	Select linetype$
		Case "solid"
			gapstep%=4
		Case "center"
			g1%=20:l1%=5:g2%=1:l2%=5
		Case "dashed"
			g1%=20:l1%=5:g2%=20:l2%=5
		Case "dotted"
			g1%=1:l1%=10:g2%=1:l2%=10
		Case "doubledash"
			g1%=10:l1%=2:g2%=10:l2%=20
		Case "crisp"
			g1%=1:l1%=2:g2%=1:l2%=2
		Default
			gapstep%=4
	End Select
	SetBuffer ImageBuffer(funcytone%)
	LockBuffer ImageBuffer(funcytone%)
	If Abs(x2#-x1#)>Abs(y2#-y1#) Then
		x#=x1#
		gap#=x#
		While x#<x2#
			x#=x#+precision#*0.02
			If x#>gap#+g1% And gapstep%=0 Then gap#=x#:gapon%=1:gapstep%=1
			If x#>gap#+l1% And gapstep%=1 Then gap#=x#:gapon%=0:gapstep%=2
			If x#>gap#+g2% And gapstep%=2 Then gap#=x#:gapon%=1:gapstep%=3
			If x#>gap#+l2% And gapstep%=3 Then gap#=x#:gapon%=0:gapstep%=0
			m#=(y2#-y1#)/(x2#-x1#)
			n#=y1#-m#*x1#
			y#=m#*x#+n#
			If x#>=0 And x#<=funcywidth% And y#>=0 And y#<=funcyheight% Then
				If gapon%=0 Then WritePixelFast x#,y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
	Else
		y#=y1#
		gap#=y#
		While y#<y2#
			y#=y#+precision#*0.02
			If y#>gap#+g1% And gapstep%=0 Then gap#=y#:gapon%=1:gapstep%=1
			If y#>gap#+l1% And gapstep%=1 Then gap#=y#:gapon%=0:gapstep%=2
			If y#>gap#+g2% And gapstep%=2 Then gap#=y#:gapon%=1:gapstep%=3
			If y#>gap#+l2% And gapstep%=3 Then gap#=y#:gapon%=0:gapstep%=0
			m#=(x2#-x1#)/(y2#-y1#)
			n#=x1#-m#*y1#
			x#=m#*y#+n#
			If x#>=0 And x#<=funcywidth% And y#>=0 And y#<=funcyheight% Then
				If gapon%=0 Then WritePixelFast x#,y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
	End If
	UnlockBuffer ImageBuffer(funcytone%)
	SetBuffer BackBuffer()
End Function

Function DrawFuncyArc(mx#,my#,r#,a1#,a2#,linetype$,linecolor$)
	Local gap#,gapon%,gapstep%,a#,x#,y#,g1%,l1%,g2%,l2%,red%,green%,blue%
	Select linecolor$
		Case "white"
			red%=255:green%=255:blue%=255
		Case "red"
			red%=255:green%=0:blue%=0
		Case "green"
			red%=0:green%=255:blue%=0
		Case "blue"
			red%=0:green%=0:blue%=255
		Case "yellow"
			red%=255:green%=255:blue%=0
		Case "cyan"
			red%=0:green%=255:blue%=255
		Case "magenta"
			red%=255:green%=0:blue%=255
		Default
			red%=255:green%=255:blue%=255
	End Select
	Select linetype$
		Case "solid"
			gapstep%=4
		Case "center"
			g1%=20:l1%=5:g2%=1:l2%=5
		Case "dashed"
			g1%=20:l1%=5:g2%=20:l2%=5
		Case "dotted"
			g1%=1:l1%=10:g2%=1:l2%=10
		Case "doubledash"
			g1%=10:l1%=2:g2%=10:l2%=20
		Case "crisp"
			g1%=1:l1%=2:g2%=1:l2%=2
		Default
			gapstep%=4
	End Select
	SetBuffer ImageBuffer(funcytone%)
	LockBuffer ImageBuffer(funcytone%)
	If a1#<a2# Then
		a#=a1#
		While a#<a2#
			a#=a#+precision#/r#
			If a#>gap#+(g1%*60)/r# And gapstep%=0 Then gap#=a#:gapon%=1:gapstep%=1
			If a#>gap#+(l1%*60)/r# And gapstep%=1 Then gap#=a#:gapon%=0:gapstep%=2
			If a#>gap#+(g2%*60)/r# And gapstep%=2 Then gap#=a#:gapon%=1:gapstep%=3
			If a#>gap#+(l2%*60)/r# And gapstep%=3 Then gap#=a#:gapon%=0:gapstep%=0
			x#=r#*Cos(a#)
			If a#<=180 And a#>=0 Then y#=Sqr(r#^2-x#^2) Else y#=Sqr(r#^2-x#^2)*-1
			If mx#+x#>=0 And mx#+x#<=funcywidth% And my#+y#>=0 And my#+y#<=funcyheight% And gapon%=0 Then
				WritePixelFast mx#+x#,my#+y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
	Else
		a#=a1#
		While a#<360
			a#=a#+precision#/r#
			If a#>gap#+(g1%*60)/r# And gapstep%=0 Then gap#=a#:gapon%=1:gapstep%=1
			If a#>gap#+(l1%*60)/r# And gapstep%=1 Then gap#=a#:gapon%=0:gapstep%=2
			If a#>gap#+(g2%*60)/r# And gapstep%=2 Then gap#=a#:gapon%=1:gapstep%=3
			If a#>gap#+(l2%*60)/r# And gapstep%=3 Then gap#=a#:gapon%=0:gapstep%=0
			x#=r#*Cos(a#)
			If a#<=180 And a#>=0 Then y#=Sqr(r#^2-x#^2) Else y#=Sqr(r#^2-x#^2)*-1
			If mx#+x#>=0 And mx#+x#<=funcywidth% And my#+y#>=0 And my#+y#<=funcyheight% And gapon%=0 Then
				WritePixelFast mx#+x#,my#+y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
		gap#=0
		a#=0
		While a#<a2#
			a#=a#+precision#/r#
			If a#>gap#+(g1%*60)/r# And gapstep%=0 Then gap#=a#:gapon%=1:gapstep%=1
			If a#>gap#+(l1%*60)/r# And gapstep%=1 Then gap#=a#:gapon%=0:gapstep%=2
			If a#>gap#+(g2%*60)/r# And gapstep%=2 Then gap#=a#:gapon%=1:gapstep%=3
			If a#>gap#+(l2%*60)/r# And gapstep%=3 Then gap#=a#:gapon%=0:gapstep%=0
			x#=r#*Cos(a#)
			If a#<=180 And a#>=0 Then y#=Sqr(r#^2-x#^2) Else y#=Sqr(r#^2-x#^2)*-1
			If mx#+x#>=0 And mx#+x#<=funcywidth% And my#+y#>=0 And my#+y#<=funcyheight% And gapon%=0 Then
				WritePixelFast mx#+x#,my#+y#,red% Shl 16+green% Shl 8+blue%
			End If
		Wend
	End If
	UnlockBuffer ImageBuffer(funcytone%)
	SetBuffer BackBuffer()
End Function

Function ClearFuncyElements()
	SetBuffer ImageBuffer(funcytone%)
	ClsColor 20,20,20:Cls
	SetBuffer BackBuffer()
End Function
;~IDEal Editor Parameters:
;~F#3#7#E#5D#A8#FD
;~C#Blitz3D