AppTitle "FuncyElements - Sample 02"

Include "FuncyElements.bb"

Global gw%=1680
Global gh%=1050
Global precision#=50

Graphics gw%,gh%,0,2
InitFuncyElements(gw%,gh%)

Local timer%=CreateTimer(60),n%
Local z#=1,oldz#,mxc%,myc%,quickdraw%,cleandraw%,ofr%,overscan%=200

Dim posx%(10000),posy%(10000),rad%(10000),posx2%(10000),posy2%(10000)

For n%=1 To 100
	posx%(n%)=Rand(gw%)
	posy%(n%)=Rand(gh%)
	posx2%(n%)=Rand(gw%)
	posy2%(n%)=Rand(gh%)
	rad%(n%)=Rand(10,180)
Next

While KeyHit(1)=False
	oldz#=z#
	z#=Abs(z#+MouseZSpeed()*0.1)
	If MouseDown(1)=True Or z#<>oldz# Then
		mxc%=mxc%+(MouseX()-gw%*0.5)*0.05
		myc%=myc%+(MouseY()-gh%*0.5)*0.05
		quickdraw%=1
		precision#=200*z#
	Else
		quickdraw%=0
		cleandraw%=1
		precision#=50
	End If
	
	If quickdraw%=1 Or cleandraw%=1 Then
		
		ClearFuncyElements()
		
		For n%=1 To 100
			overscan%=rad%(n%)*z#
			If ((posx%(n%)*z#)-mxc%>0-overscan% And (posx%(n%)*z#)-mxc%<gw%+overscan% And (posy%(n%)*z#)-myc%>0-overscan% And (posy%(n%)*z#)-myc%<gh%+overscan%) Or ((posx2%(n%)*z#)-mxc%>0-overscan% And (posx2%(n%)*z#)-mxc%<gw%+overscan% And (posy2%(n%)*z#)-myc%>0-overscan% And (posy2%(n%)*z#)-myc%<gh%+overscan%) Then
				DrawFuncyArc((posx%(n%)*z#)-mxc%,(posy%(n%)*z#)-myc%,(rad%(n%)*z#),rad%(n%)*2,(rad%(n%)*2)-90,"solid","green")
				DrawFuncyLine(((posx%(n%)-rad%(n%)-10)*z#)-mxc%,(posy%(n%)*z#)-myc%,((posx%(n%)+rad%(n%)+10)*z#)-mxc%,(posy%(n%)*z#)-myc%,"center","white")
				DrawFuncyLine((posx%(n%)*z#)-mxc%,((posy%(n%)-rad%(n%)-10)*z#)-myc%,(posx%(n%)*z#)-mxc%,((posy%(n%)+rad%(n%)+10)*z#)-myc%,"center","white")
			End If
		Next
		Cls
		UpdateFuncyElements()
		
		Flip
		If cleandraw%=1 Then cleandraw%=0
		
	End If
	
	WaitTimer(timer%)
Wend
End


;~IDEal Editor Parameters:
;~C#Blitz3D